Imports System.Data
Imports System.Data.SqlClient
Imports System.Net.Mail

Partial Class My_account
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        ' This code will only be executed if the page load not is a PostBack, a PostBack is when a button is clicked
        ' on the web form for instance.
        If Page.IsPostBack = False Then

            ' The Try/Catch/Finally block is used to handle exceptions in the code to avoid having a crash in
            ' the application when an exception occurs.
            Try

                ' Check if the user have the authority to see this page, he have to be logged in.
                Dim user As String = Page.User.Identity.Name

                ' Declare variables for the connection string and the SELECT statement.
                Dim ConnString As String = ConfigurationManager.ConnectionStrings("ConnectionString").ToString()
                Dim sql As String = "SELECT * FROM Users WHERE Username = @UserName"

                ' The Using block is used to call dispose (close) automatically even if there are an exception.
                Using cn As New SqlConnection(ConnString), _
                      cmd As New SqlCommand(sql, cn)

                    ' Add parameters for the WHERE clause, parameters are used to make it hard for hackers to modify
                    ' the sql statement.
                    cmd.Parameters.AddWithValue("@UserName", user)

                    ' Open the Sql connection.
                    cn.Open()

                    ' We use SqlDataReader and just want to select one single row, the Using block
                    ' is used to call dispose (close) automatically even if there are an exception.
                    Using reader As SqlDataReader = cmd.ExecuteReader(CommandBehavior.SingleRow)

                        ' Loop through the reader.
                        While reader.Read()
                            txtUserID.Text = reader("UserID").ToString()
                            txtUserName.Text = reader("Username").ToString()
                            txtCompanyName.Text = reader("Company").ToString()
                            txtOrganisationNumber.Text = reader("OrgNumber").ToString()
                            txtContact.Text = reader("Contact").ToString()
                            txtAttention.Text = reader("Attention").ToString()
                            txtAdress.Text = reader("Adress").ToString()
                            txtPostalCode.Text = reader("PostalCode").ToString()
                            txtCity.Text = reader("City").ToString()
                            txtCountry.Text = reader("Country").ToString()
                        End While

                    End Using

                End Using

            Catch ex As Exception

                ' Catch a general exception
                Response.Write(ex.Message)

            End Try

        End If
    End Sub
    Protected Sub btnUpdate_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnUpdate.Click

        ' Set the text for the SqlEx label to a empty string.
        SqlEx.Text = String.Empty

        ' The Try/Catch/Finally block is used to handle exceptions in the code to avoid having a crash in
        ' the application when an exception occurs.
        Try
            ' Update user information according to the users changes for the specific UserID in the Users table
            Dim ConnString As String = ConfigurationManager.ConnectionStrings("ConnectionString").ToString()
            Dim sql As String = "UPDATE Users SET Username=@Username, Company=@Company, OrgNumber=@OrgNumber, Contact=@Contact, Attention=@Attention, Adress=@Adress, PostalCode=@PostalCode, City=@City, Country=@Country WHERE UserID=@UserID"

            ' The Using block is used to call dispose (close) automatically even if there are an exception.
            Using cn As New SqlConnection(ConnString), _
                  cmd As New SqlCommand(sql, cn)

                ' Add parameters for the WHERE clause, parameters are used to make it hard for hackers to modify
                ' the sql statement.
                cmd.Parameters.Add("@UserID", Data.SqlDbType.Int).Value = txtUserID.Text
                cmd.Parameters.Add("@Username", Data.SqlDbType.VarChar, 80).Value = txtUserName.Text
                cmd.Parameters.Add("@Company", Data.SqlDbType.VarChar, 50).Value = txtCompanyName.Text
                cmd.Parameters.Add("@OrgNumber", Data.SqlDbType.VarChar, 15).Value = txtOrganisationNumber.Text
                cmd.Parameters.Add("@Contact", Data.SqlDbType.VarChar, 50).Value = txtContact.Text
                cmd.Parameters.Add("@Attention", Data.SqlDbType.VarChar, 50).Value = txtAttention.Text
                cmd.Parameters.Add("@Adress", Data.SqlDbType.VarChar, 50).Value = txtAdress.Text
                cmd.Parameters.Add("@PostalCode", Data.SqlDbType.VarChar, 10).Value = txtPostalCode.Text
                cmd.Parameters.Add("@City", Data.SqlDbType.VarChar, 50).Value = txtCity.Text
                cmd.Parameters.Add("@Country", Data.SqlDbType.VarChar, 50).Value = txtCountry.Text

                ' Open the Sql connection.
                cn.Open()

                ' Execute the UPDATE statement.
                cmd.ExecuteNonQuery()

                ' Send an e-mail to the user
                CustomerMailChangeUserInfo()

                ' Logout the user because the Username could have been changed
                LogoutUser()

            End Using

        Catch SqlExc As SqlException

            ' Catch a SqlException
            Select Case SqlExc.Number
                Case 2601
                    SqlEx.Text = "* Given E-mail already exists"
                Case Else
                    Response.Write(SqlExc.Message)
            End Select
        Catch Ex As Exception

            ' Catch a general exception, you dont need to write this message.
            Response.Write(Ex.Message)

        End Try
    End Sub
    Protected Sub btnChangePassword_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnChangePassword.Click
       
        Try
            ' Update the password field in the Users table for the specific UserID according to what the user has entered
            Dim ConnString As String = ConfigurationManager.ConnectionStrings("ConnectionString").ToString()
            Dim sql As String = "UPDATE Users SET Password=@Password WHERE UserID=@UserID"

            ' The Using block is used to call dispose (close) automatically even if there are an exception.
            Using cn As New SqlConnection(ConnString), _
                  cmd As New SqlCommand(sql, cn)
                cmd.Parameters.Add("@UserID", Data.SqlDbType.Int).Value = txtUserID.Text
                cmd.Parameters.Add("@Password", Data.SqlDbType.VarChar, 80).Value = txtPassword.Text

                cn.Open()
                cmd.ExecuteNonQuery()
                ' Send email to the user
                CustomerMailChangePassword()
                ' Logout the user because the password have been changed
                LogoutUser()

            End Using
        Catch ex As SqlException
            Response.Write(ex.Message)
        End Try
    End Sub
    Private Sub CustomerMailChangeUserInfo()
        Dim ToAddress As String = txtUserName.Text

        ' Create the email message
        Dim SendEmail As New MailMessage("info@mycompany.com", ToAddress)

        ' Properties for the email message
        SendEmail.Subject = "Updated data!"
        SendEmail.Body = "<html><body><b>Updated data!!</b><br />You receive this email because of updated user information. Your E-mail is now as follows:<br /><br />E-mail:" & " " & txtUserName.Text & "</body></html>"
        SendEmail.IsBodyHtml = True

        ' Send the MailMessage (will use the Web.config settings)
        Dim smtp As New SmtpClient
        smtp.Send(SendEmail)
    End Sub
    Private Sub CustomerMailChangePassword()
        Dim ToAddress As String = txtUserName.Text

        ' Create the mail message
        Dim SendEmail As New MailMessage("info@mycompany.com", ToAddress)

        'Properties for the mail message
        SendEmail.Subject = "Changed password!"
        SendEmail.Body = "<html><body><b>Changed password!</b><br />You are receiving this email because you have changed your password. Your new password is now as follows:<br /><br />Password:" & " " & txtPassword.Text & "</body></html>"
        SendEmail.IsBodyHtml = True

        ' Send the MailMessage (will use the Web.config settings)
        Dim smtp As New SmtpClient
        smtp.Send(SendEmail)

    End Sub
    Private Sub LogoutUser()
        FormsAuthentication.SignOut()
        FormsAuthentication.RedirectToLoginPage()
    End Sub
End Class

