using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
// Import Microsoft SqlClient and the email namespace.
using System.Data.SqlClient;
using System.Net.Mail;

public partial class _UpdateMsSql : System.Web.UI.Page 
{
    protected void Page_Load(object sender, System.EventArgs e)
    {
        // This code will only be executed if the page load not is a PostBack, a PostBack occurs when a button is clicked
        // on a web form for instance.
        if (!Page.IsPostBack)
        {

            // Declare user as a string and assign a username to the variable.
            //string user = Page.User.Identity.Name;
            string user = "info@mysite.com";

            // Declare variables for the connection string and the SELECT statement.
            string ConnString = ConfigurationManager.ConnectionStrings["ConnectionString"].ToString();
            string sql = "SELECT * FROM Users WHERE Username = @UserName";

            // The using block is used to call dispose (close) automatically even if there are an exception.
            using (SqlConnection cn = new SqlConnection(ConnString))
            {
                // Create a SqlCommand.
                SqlCommand cmd = new SqlCommand(sql, cn);

                // Create a SqlDataReader
                SqlDataReader reader = null;

                // Add parameters for the WHERE clause, parameters are used to make it hard for hackers to modify
                // the sql statement.
                cmd.Parameters.AddWithValue("@UserName", user);

                // The Try/Catch/Finally block is used to handle exceptions in the code to avoid having a crash in
                // the application when an exception occurs.
                try
                {
                    // Open the Sql connection.
                    cn.Open();

                    // We use SqlDataReader and just want to select one single row.
                    reader = cmd.ExecuteReader(CommandBehavior.SingleRow);

                    // Loop through the reader.
                    while (reader.Read())
                    {
                        txtUserID.Text = reader["UserID"].ToString();
                        txtUserName.Text = reader["Username"].ToString();
                        txtCompanyName.Text = reader["Company"].ToString();
                        txtOrganisationNumber.Text = reader["OrgNumber"].ToString();
                        txtContact.Text = reader["Contact"].ToString();
                        txtAttention.Text = reader["Attention"].ToString();
                        txtAdress.Text = reader["Adress"].ToString();
                        txtPostalCode.Text = reader["PostalCode"].ToString();
                        txtCity.Text = reader["City"].ToString();
                        txtCountry.Text = reader["Country"].ToString();
                    }

                }
                catch (Exception ex)
                {
                    // Catch a general exception
                    Response.Write(ex.Message);
                }
                finally
                {
                    // Dispose the SqlCommand and close the SqlDataReader to avoid memory leakage.
                    cmd.Dispose();

                    if (reader != null)
                        reader.Close();
                }
            }
        }
    }

    protected void btnUpdate_Click(object sender, System.EventArgs e)
    {

        // Set the text for the SqlEx label to a empty string.
        SqlEx.Text = string.Empty;

        // Update user information according to the users changes for the specific UserID in the Users table.
        // Declare variables for the connection string and the UPDATE statement.
        string ConnString = ConfigurationManager.ConnectionStrings["ConnectionString"].ToString();
        string sql = "UPDATE Users SET Username=@Username, Company=@Company, OrgNumber=@OrgNumber, "
        + "Contact=@Contact, Attention=@Attention, Adress=@Adress, PostalCode=@PostalCode, City=@City, "
        + "Country=@Country WHERE UserID=@UserID";

        // The using block is used to call dispose (close) automatically even if there are an exception.
        using (SqlConnection cn = new SqlConnection(ConnString))
        {

            // Create a new SqlCommand.
            SqlCommand cmd = new SqlCommand(sql, cn);

            // Add parameters for the WHERE clause, parameters are used to make it hard for hackers to modify
            // the sql statement.
            cmd.Parameters.AddWithValue("@UserID", txtUserID.Text);
            cmd.Parameters.AddWithValue("@Username", txtUserName.Text);
            cmd.Parameters.AddWithValue("@Company", txtCompanyName.Text);
            cmd.Parameters.AddWithValue("@OrgNumber", txtOrganisationNumber.Text);
            cmd.Parameters.AddWithValue("@Contact", txtContact.Text);
            cmd.Parameters.AddWithValue("@Attention", txtAttention.Text);
            cmd.Parameters.AddWithValue("@Adress", txtAdress.Text);
            cmd.Parameters.AddWithValue("@PostalCode", txtPostalCode.Text);
            cmd.Parameters.AddWithValue("@City", txtCity.Text);
            cmd.Parameters.AddWithValue("@Country", txtCountry.Text);

            // The Try/Catch/Finally block is used to handle exceptions in the code to avoid having a crash in
            // the application when an exception occurs.
            try
            {
                // Open the Sql connection.
                cn.Open();

                // Execute the UPDATE statement.
                cmd.ExecuteNonQuery();

                //// Send an e-mail to the user
                //CustomerMailChangeUserInfo();

                //// Logout the user because the Username could have been changed
                //LogoutUser();
            }
            catch (SqlException SqlExc)
            {
                // Catch a SqlException
                switch (SqlExc.Number)
                {
                    case 2601:
                        SqlEx.Text = "* Given E-mail already exists";
                        break;
                    default:
                        Response.Write(SqlExc.Message);
                        break;
                }
            }
            catch (Exception Ex)
            {
                // Catch a general exception.
                Response.Write(Ex.Message);
            }
            finally
            {
                // Dispose the SqlCommand to avoid memory leakage.
                cmd.Dispose();
            }
        }
    }

    protected void btnChangePassword_Click(object sender, System.EventArgs e)
    {
        // Update the password field in the Users table for the specific UserID according to what the user has entered.
        // Declare variables for the connection string and the UPDATE statement.
        string ConnString = ConfigurationManager.ConnectionStrings["ConnectionString"].ToString();
        string sql = "UPDATE Users SET Password=@Password WHERE UserID=@UserID";

        // The Using block is used to call dispose (close) automatically even if there are an exception.
        using (SqlConnection cn = new SqlConnection(ConnString))
        {
            // Create a new SqlCommand.
            SqlCommand cmd = new SqlCommand(sql, cn);

            // Add parameters for the WHERE clause, parameters are used to make it hard for hackers to modify
            // the sql statement.
            cmd.Parameters.AddWithValue("@UserID", txtUserID.Text);
            cmd.Parameters.AddWithValue("@Password", txtPassword.Text);

            try
            {
                // Open the Sql connection.
                cn.Open();

                // Execute the UPDATE statement.
                cmd.ExecuteNonQuery();

                //// Send email to the user
                //CustomerMailChangePassword();

                //// Logout the user because the password have been changed
                //LogoutUser();
            }
            catch (SqlException SqlExc)
            {
                Response.Write(SqlExc.Message);
            }
            catch (Exception Exc)
            {
                Response.Write(Exc.Message);
            }
            finally
            {
                // Dispose the SqlCommand to avoid memory leakage.
                cmd.Dispose();
            }
        }
    }

    private void CustomerMailChangeUserInfo()
    {
        // Declare the receiving email address as a string and assing the UserName to it.
        string ToAddress = txtUserName.Text;

        // Create the email message
        MailMessage SendEmail = new MailMessage("info@mycompany.com", ToAddress);

        // Properties for the email message
        SendEmail.Subject = "Updated data!";
        SendEmail.Body = "<html><body><b>Updated data!!</b><br />You receive this email because of updated user information. Your E-mail is now as follows:<br /><br />E-mail:" + " " + txtUserName.Text + "</body></html>";
        SendEmail.IsBodyHtml = true;

        // Send the MailMessage (we use the Web.config settings)
        SmtpClient smtp = new SmtpClient();
        smtp.Send(SendEmail);
    }

    private void CustomerMailChangePassword()
    {
        // Declare the receiving email address as a string and assing the UserName to it.
        string ToAddress = txtUserName.Text;

        // Create the mail message
        MailMessage SendEmail = new MailMessage("info@mycompany.com", ToAddress);

        //Properties for the mail message
        SendEmail.Subject = "Changed password!";
        SendEmail.Body = "<html><body><b>Changed password!</b><br />You are receiving this email because you have changed your password. Your new password is now as follows:<br /><br />Password:" + " " + txtPassword.Text + "</body></html>";
        SendEmail.IsBodyHtml = true;

        // Send the MailMessage (we use the Web.config settings)
        SmtpClient smtp = new SmtpClient();
        smtp.Send(SendEmail);
    }

    private void LogoutUser()
    {
        FormsAuthentication.SignOut();
        FormsAuthentication.RedirectToLoginPage();
    }

}
